<template>
  <div style="width: 100%; overflow: hidden">
    <div class="row" style="padding-top: 60px">
      <div class="row lt-sm" style="width: 100%">
        <div class="title-arrow-div q-pl-md" ref="toppage">
          <q-icon name="fas fa-arrow-left" />
        </div>
        <div class="col">
          <div class="ellipsis">{{ book.title }}</div>
          <div class="font-12">{{ catName }}</div>
        </div>
      </div>

      <div
        class="mainPoster row gt-xs"
        :style="{ 'background-image': 'url(' + bgFile + ')' }"
        style="width: 100%"
      >
        <div class="q-pa-md q-pt-md" style="vertical-align: middle">
          <img style="height: 300px" :src="coverPic" alt="" />
        </div>
        <div class="col q-pa-md">
          <div class="font-32">{{ book.title }}</div>
          <div>{{ catName }}</div>
          <div class="font-14 q-pt-md">{{ book.synopsis }}</div>
        </div>
      </div>
      <div class="lt-sm" :style="{ 'background-image': 'url(' + bgFile + ')' }">
        <div class="q-pa-md">
          <div class="font-18">{{ book.title }}</div>
          <div class="font-14">{{ catName }}</div>
          <div class="font-14 q-pt-md">{{ book.synopsis }}</div>
        </div>
      </div>
      <show-ads style="width: 100%" />
      <div style="min-height: 900px">
        <div
          v-for="(item, index) in pageData"
          :key="index"
          class=""
          style="width: 100%; font-size: 0px"
        >
          <img :src="convertPic(item)" style="width: 100%" />
        </div>
      </div>
      <div style="height: 100px"></div>
      <div class="menu-left row">
        <q-btn-group push>
          <q-btn
            class="menu-left-menu1"
            text-color="white"
            push
            icon="fa-solid fa-align-left"
            @click="openChapterDialog()"
          ></q-btn>

          <q-btn
            :disable="currentID == firstID"
            class="menu-arrow"
            :text-color="currentID == firstID ? 'black' : 'white'"
            push
            icon="fa-solid fa-arrow-left"
            @click="perviousBtn"
          />
          <q-btn
            :disable="currentID == lastID"
            class="menu-arrow"
            icon="fa-solid fa-arrow-right"
            :text-color="currentID == lastID ? 'black' : 'white'"
            push
            @click="nextBtn()"
          />
        </q-btn-group>
      </div>

      <div class="menu-right">
        <q-btn
          round
          push
          icon="fa-solid fa-arrow-up"
          @click="goToTop()"
          class="btn-up"
        />
      </div>
    </div>
    <show-ads />
    <div class="font-24 q-px-md q-mt-md topic">แนะนำ</div>

    <!-- Mobile -->
    <div class="lt-sm">
      <div class="showNew row no-wrap">
        <div
          v-for="(item2, index2) in data"
          :key="index2"
          align="center"
          class="q-pr-sm"
        >
          <img
            :src="openPic(item2.bookid)"
            alt=""
            class="book-m"
            @click="showBook(item2.bookid)"
          />
          <div class="cover-title-m ellipsis-3-lines q-px-sm" align="center">
            {{ item2.title }}
          </div>
        </div>
      </div>
      <div style="height: 70px"></div>
    </div>

    <!-- Tablet -->
    <div class="lt-lg gt-xs">
      <div class="showNew-t row no-wrap">
        <div
          v-for="(item2, index2) in data"
          :key="index2"
          align="center"
          class="q-pr-md main-div"
        >
          <img
            :src="openPic(item2.bookid)"
            alt=""
            class="book-t"
            @click="showBook(item2.bookid)"
          />
          <div class="cover-title-m ellipsis-3-lines q-px-sm" align="left">
            {{ item2.title }}
          </div>
        </div>
      </div>
      <div style="height: 70px"></div>
    </div>

    <q-dialog v-model="chapterDialog" persistent>
      <q-card class="chapter-main-div">
        <div class="dialog-select-div">
          <div class="row">
            <div class="col"></div>
            <div class="q-pt-md q-pr-md">ลำดับ</div>
            <div class="q-pr-md">
              <q-select
                v-model="page"
                :options="pageOptions"
                map-options
                emit-value
                dense
                @input="selectChapter()"
              />
            </div>
          </div>
        </div>
        <div class="dialog-body-div">
          <q-list separator>
            <q-item
              clickable
              v-ripple
              v-for="(item, index) in chapterShow"
              :key="index"
              @click="selectPage(item.id)"
            >
              <div
                class="row justify-between text-primary"
                style="width: 100%"
                v-if="item.id == currentID"
              >
                <div>ตอน {{ item.chapter }}</div>
                <div class="text-primary">{{ dateShow(item.timestamp) }}</div>
              </div>
              <div
                class="row justify-between"
                style="width: 100%"
                v-if="item.id != currentID"
              >
                <div>ตอน {{ item.chapter }}</div>
                <div class="font-grey">{{ dateShow(item.timestamp) }}</div>
              </div>
            </q-item>
          </q-list>
        </div>
        <div class="dialog-close-div row items-center justify-center">
          <div @click="closeChapterDialog()">
            <img src="../../../public/image/close.svg" alt="" />
          </div>
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
import showAds from "../../components/ads.vue";

export default {
  components: { showAds },
  props: ["bookData", "catData", "chapterData"],
  data() {
    return {
      coverPic: "",
      bgFile: "",
      chapterPerPage: 50,
      book: {
        title: "",
        synopsis: "",
      },
      catName: "",
      chapterDialog: false,
      pageOptions: [],
      page: 0,
      chapterShow: [],
      chapterCurrent: 1,
      pageData: [],
      pageShow: [],
      lastID: 0,
      nextBtnEnable: true,
      firstID: 0,
      perviousBtnEnable: true,
      currentID: 0,
      data: [],
    };
  },
  methods: {
    openPic(id) {
      return this.serverpath + "cover/" + id + ".jpg";
    },
    async loadCartoonFooter() {
      let url = this.serverpath + "cartoononfooter.php";
      let res = await axios.get(url);
      this.data = res.data;
    },
    showBook(id) {
      this.$router.push("/reload/" + id);
    },
    nextBtn() {
      let currentIndex = this.pageShow.findIndex((x) => x.id == this.currentID);
      let setId = this.pageShow[currentIndex + 1].id;
      this.loadPage(setId);
    },
    perviousBtn() {
      let currentIndex = this.pageShow.findIndex((x) => x.id == this.currentID);
      let setId = this.pageShow[currentIndex - 1].id;
      this.loadPage(setId);
    },
    async selectPage(id) {
      // console.log("test");

      await this.loadPage(id);

      this.chapterDialog = false;
    },
    async loadPage(id) {
      this.currentID = id;

      // console.log(this.firstID, this.lastID, id);
      let pathfile = "cartoon/" + this.bookData[0].folder + "/" + id;
      let dataSend = {
        pathfile: pathfile,
      };

      let url = this.serverpath + "fe_filelist.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.pageData = res.data;
      setTimeout(() => {
        window.scrollTo(0, 0);
      }, 300);
    },
    dateShow(dateRaw) {
      let datetemp = dateRaw.split(" ")[0].split("-");
      return datetemp[2] + "/" + datetemp[1] + "/" + datetemp[0];
    },
    selectChapter() {
      this.chapterShow = [];
      let itemStart = (this.page - 1) * this.chapterPerPage;
      let itemEnd = this.page * this.chapterPerPage;

      this.chapterShow = this.pageShow.slice(itemStart, itemEnd);
      this.chapterShow.sort((a, b) => Number(b.orderid) - Number(a.orderid));
    },
    closeChapterDialog() {
      this.chapterDialog = false;
    },
    openChapterDialog() {
      this.chapterDialog = true;
    },
    goToTop() {
      window.scrollTo(0, 0);
    },
    convertPic(item) {
      return this.serverpath + "/" + item;
    },
    findCatName(catid) {
      let catFinal = "";
      let cattemp = catid.split(",");

      cattemp.forEach((item) => {
        item = item.replace("[", "").replace("]", "");
        let cat = this.catData.filter((x) => x.catid == item);
        catFinal += cat[0].name + " | ";
      });
      catFinal = catFinal.slice(0, -3);

      return catFinal;
    },
    loadChaptertoSelect() {
      let chapterLength = this.chapterData.length;
      let pageNumber = Math.ceil(chapterLength / this.chapterPerPage);
      for (let i = 1; i < pageNumber; i++) {
        let labelTemp1 = (i - 1) * this.chapterPerPage + 1;
        let labelTemp2 = i * this.chapterPerPage;
        let tempInput = {
          value: i,
          label: labelTemp1 + " - " + labelTemp2,
        };
        this.pageOptions.push(tempInput);
      }
      let labelTemp1 = (pageNumber - 1) * this.chapterPerPage + 1;
      let labelTemp2 = chapterLength;
      let tempInput = {
        value: pageNumber,
        label: labelTemp1 + " - " + labelTemp2,
      };
      this.pageOptions.push(tempInput);
      this.pageOptions.reverse();
      this.page = this.pageOptions[0].value;
      this.selectChapter();
    },
    loadData() {
      this.loadingShow();
      setTimeout(() => {
        // console.log("book");
        // console.log(this.bookData);
        // console.log("first");
        // console.log(this.pageShow);
        this.bgFile =
          this.serverpath +
          "bg/" +
          this.bookData[0].bookid +
          ".jpg?" +
          Math.random() * 2000;

        this.coverPic =
          this.serverpath +
          "cover/" +
          this.bookData[0].bookid +
          ".jpg?" +
          Math.random() * 2000;
        this.pageShow = [...this.chapterData];
        // this.pageShow.reverse();
        this.firstID = this.pageShow[0].id;
        this.lastID = this.pageShow[this.pageShow.length - 1].id;
        this.catName = this.findCatName(this.bookData[0].catid);
        this.book.title = this.bookData[0].title;
        this.book.synopsis = this.bookData[0].synopsis;
        this.loadChaptertoSelect();
        this.loadPage(this.pageShow[this.pageShow.length - 1].id);
        this.loadingHide();
      }, 2500);
    },
  },
  mounted() {
    this.loadData();
    this.loadCartoonFooter();
  },
};
</script>

<style lang="scss" scoped>
.showNew {
  width: 100%;
  position: relative;
  // height: 320px;
  padding-top: 20px;
  overflow-x: auto;
  overflow-y: hidden;
  -ms-overflow-style: none; /* Internet Explorer 10+ */
  scrollbar-width: none; /* Firefox */
}
.showNew::-webkit-scrollbar {
  display: none; /* Safari and Chrome */
}
.title-arrow-div {
  width: 50px;
}
.menu-left {
  position: fixed;
  width: 240px;
  height: 55px;
  background-color: #3b3d4b;
  bottom: 30px;
  left: 20px;
  border-radius: 5px;
  z-index: 1000;
}
.menu-left-menu1 {
  background-color: #2d6be4;
  border-radius: 5px 0px 0px 5px;
  text-align: center;
  // padding-top: 12px;
  width: 80px;
}
.menu-arrow {
  width: 80px;
  color: white;
  // text-align: center;
  // padding-top: 12px;
}
.menu-right {
  position: fixed;
  bottom: 30px;
  right: 20px;
  z-index: 1000;
  // width: 45px;
  // height: 45px;
  // border-radius: 100px;
  // background-color: #2d6be4;
  // text-align: center;
  // padding-top: 12px;
}
.chapter-main-div {
  width: 100%;
  min-width: 100%;
  height: 80vh;
}
.dialog-close-div {
  height: 100px;
  width: 100%;
  text-align: center;
}
.dialog-select-div {
  height: 60px;
  width: 100%;
  text-align: right;
}
.dialog-body-div {
  height: calc(80vh - 60px - 100px);
  width: 100%;
  overflow-y: auto;
}
.btn-up {
  background-color: #2d6be4;
  color: white;
  width: 55px;
  height: 55px;
}
.main-div {
  position: relative;
}
.book-m {
  width: 140px;
  height: 210px;
}
.cover-title-m {
  width: 150px;
  font-size: 14px;
  height: 60px;
  margin-bottom: 20px;
}
.showNew-t {
  width: 100%;
  height: 360px;
  padding-top: 20px;
  overflow-x: auto;
  overflow-y: hidden;
}
.book-t {
  width: 170px;
  height: 255px;
}
</style>
